.EQ
delim off
.EN
.\" documentation file generated from ../../../../../src/contrib/atrade/de/stars/DEFunction.pl by ptlang
.\" Copyright (c) 1995 Sanders, a Lockheed Martin Company
.\" All rights reserved.
.NA "Function"
.SD
Models the performance of an SDF star based on cycles and memory needed.
.SE
.LO "$PTOLEMY/src/contrib/atrade/de/stars"
.DM DE DEStar
.SV 1.7 "1995/07/19 18:45:45"
.AL "E. K. Pauer"
.AC "This work was performed by Sanders, a Lockheed Martin Company, as part
of the Sanders RASSP program under contract N00014-93-C-2172 to the
Naval Research Laboratory, 4555 Overlook Avenue, SW, Washington, DC
20375-5326. The Sponsoring Agency is: Advanced Research Projects
Agency, Electronic System Technology Office, 3701 North Fairfax
Drive, Arlington, VA 22203-1714. The Sanders RASSP team consists of
Sanders, Motorola, Hughes, and ISX."
.IH
.NE
\fIinputPort\fR (multiple), (message)
.NE
\fIacknowledge\fR (message)
.PE
.OH
.NE
\fIoutputPort\fR (multiple), (message)
.NE
\fIrequest\fR (message)
.PE
.SH
.NE
\fIfunctionName\fR (StringState): Name of function implemented
.DF ""
.NE
\fIfunctionNumber\fR (IntState): Unique id of the functional block
.DF "0"
.NE
\fIinputSamples\fR (IntArrayState): DataBlocks needed on each input for star to fire
.DF "1"
.NE
\fIoutputSamples\fR (IntArrayState): DataBlocks produced on each output per each firing
.DF "1"
.NE
\fIinputDataType\fR (StringArrayState): Type of data accepted by each inputPort
.DF "FLOAT"
.NE
\fIoutputDataType\fR (StringArrayState): Type of data produced by each outputPort
.DF "FLOAT"
.NE
\fIprocessingCostOverhead\fR (IntState): number of overhead CPU cycles needed to fire
.DF "15"
.NE
\fIprocessingUnitCost\fR (IntState): number of CPU cycles needed to fire which is scalable by the amount of data
.DF "10"
.NE
\fImemoryCostOverhead\fR (IntState): bytes of overhead memory needed to fire
.DF "20"
.NE
\fImemoryUnitCost\fR (IntState): bytes of overhead memory needed to fire which is dependent of the amount of data
.DF "8"
.NE
\fIvectorizable\fR (IntState): specifies whether or not function can process more than one data particle per firing
.DF "1"
.NE
\fIprocessorMapping\fR (IntArrayState): List of processors (by number) of the function blocks mapped to outputPort
.DF "0"
.NE
\fIfunctionBlockMapping\fR (IntArrayState): List of function blocks (by number) mapped to outputPort
.DF "0"
.NE
\fIinputPortMapping\fR (IntArrayState): List of inputPorts (by number) of the functional blocks mapped to outputPort
.DF "0"
.ET
.EQ
delim $$
.EN
.ES
