defstar {
	name {I860}
	domain {DE}
	version { $Revision: 1.4 $ $Date: 1995/07/17 23:58:38 $ }
	author { E. K. Pauer }
	copyright {
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
	}
	acknowledge {
This work was performed by Sanders, a Lockheed Martin Company, as part
of the Sanders RASSP program under contract N00014-93-C-2172 to the
Naval Research Laboratory, 4555 Overlook Avenue, SW, Washington, DC
20375-5326. The Sponsoring Agency is: Advanced Research Projects
Agency, Electronic System Technology Office, 3701 North Fairfax
Drive, Arlington, VA 22203-1714. The Sanders RASSP team consists of
Sanders, Motorola, Hughes, and ISX.
}
	location { $PTOLEMY/src/contrib/atrade/de/stars }
	desc { Provides state info for creating i860 processor }
	output {
		name {externalOutput}
		type {ANYTYPE}
	}
	defstate {
		name {partNumber}
		type {string}
		default {"I860"}
		desc { Type of processor by part number }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {processorNumber}
		type {int}
		default {0}
		desc { Unique id of the processor }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {clockRate}
		type {int}
		default {50000000}
		desc { Clock rate of the processor }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {inputSampleTransferRate}
		type {int}
		default {200000000}
		desc { Transfer rate of data at input }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {outputSampleTransferRate}
		type {int}
		default {200000000}
		desc { Transfer rate of data at output }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {functionBlockMapping}
		type {intarray}
		default {0}
		desc { List of function blocks (by number) mapped to internalOutput }
		attributes { A_CONSTANT | A_SETTABLE }
	}
	defstate {
		name {inputPortMapping}
		type {intarray}
		default {0}
		desc { List of input ports (by number) of the functional blocks mapped to internalOutput }
		attributes { A_CONSTANT | A_SETTABLE }
	}
}
