static const char file_id[] = "../../../../../src/contrib/atrade/sdf/stars/SDFNormalize.pl";
// .cc file generated from ../../../../../src/contrib/atrade/sdf/stars/SDFNormalize.pl by ptlang
/*
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFNormalize.h"
#include <math.h>

const char *star_nm_SDFNormalize = "SDFNormalize";

const char* SDFNormalize :: className() const {return star_nm_SDFNormalize;}

ISA_FUNC(SDFNormalize,SDFStar);

Block* SDFNormalize :: makeNew() const { LOG_NEW; return new SDFNormalize;}

SDFNormalize::SDFNormalize ()
{
	setDescriptor("Normalizes complex input vector for magnitude of 1");
	addState(blockSize.setState("blockSize",this,"256","Size of vector"));
	addPort(vin.setPort("vin",this,COMPLEX));
	addPort(qout.setPort("qout",this,COMPLEX));


}

void SDFNormalize::setup() {
# line 36 "../../../../../src/contrib/atrade/sdf/stars/SDFNormalize.pl"
vin.setSDFParams(int(blockSize), int(blockSize)-1);
	  qout.setSDFParams(int(blockSize), int(blockSize)-1);
}

void SDFNormalize::go() {
# line 42 "../../../../../src/contrib/atrade/sdf/stars/SDFNormalize.pl"
double normFactor, power = 0.0;
		int i;
		for (i = int(blockSize)-1; i >= 0; i--)
		  power += norm(Complex(vin%i));
		normFactor = 1.0 / sqrt(power);
		for (i = int(blockSize)-1; i >= 0; i--)
		  qout%i << Complex((vin%i)) * Complex(normFactor);
}

// prototype instance for known block list
static SDFNormalize proto;
static RegisterBlock registerBlock(proto,"Normalize");
