defstar {
	name { Orthogonalize }
	domain { SDF }
	version { $Revision: 1.2 $ $Date: 1995/07/19 14:48:30 $ }
	author { E. K. Pauer }
	copyright {
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
	}
        acknowledge {
This work was performed by Sanders, a Lockheed Martin Company, as part
of the Sanders RASSP program under contract N00014-93-C-2172 to the
Naval Research Laboratory, 4555 Overlook Avenue, SW, Washington, DC
20375-5326. The Sponsoring Agency is: Advanced Research Projects
Agency, Electronic System Technology Office, 3701 North Fairfax
Drive, Arlington, VA 22203-1714. The Sanders RASSP team consists of
Sanders, Motorola, Hughes, and ISX.
}
	location { $PTOLEMY/src/contrib/atrade/sdf/stars }
	desc { Orthogonalizes the complex input vector with the given complex basis vector }
        defstate {
                name {blockSize}
	        type {int}
		default {256}
		desc {Size of vector}
	}
	input {
		name{vin}
		type{complex}
	}
	input {
		name{qin}
		type{complex}
	}
	output {
		name{vout}
		type{complex}
	}
	output {
		name{qout}
		type{complex}
	}
	setup {
	  vin.setSDFParams(int(blockSize), int(blockSize)-1);
	  qin.setSDFParams(int(blockSize), int(blockSize)-1);
	  vout.setSDFParams(int(blockSize), int(blockSize)-1);
	  qout.setSDFParams(int(blockSize), int(blockSize)-1);
	}

	ccinclude { <math.h> }
	go {
                Complex r(0.0, 0.0);
		int i;
		for (i = int(blockSize)-1; i >= 0; i--)
		  r = r + (Complex(vin%i) * conj(Complex(qin%i)));
		for (i = int(blockSize)-1; i >= 0; i--) {
	          vout%i << (Complex(vin%i) - Complex(Complex(r) * Complex(qin%i)));
		  qout%i << Complex(qin%i);
	        }
	}
}
