static const char file_id[] = "../../../../../src/contrib/atrade/sdf/stars/SDFReadComplexFile.pl";
// .cc file generated from ../../../../../src/contrib/atrade/sdf/stars/SDFReadComplexFile.pl by ptlang
/*
Copyright (c) 1995 Sanders, a Lockheed Martin Company
All rights reserved.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFReadComplexFile.h"
#include "SimControl.h"

const char *star_nm_SDFReadComplexFile = "SDFReadComplexFile";

const char* SDFReadComplexFile :: className() const {return star_nm_SDFReadComplexFile;}

ISA_FUNC(SDFReadComplexFile,SDFStar);

Block* SDFReadComplexFile :: makeNew() const { LOG_NEW; return new SDFReadComplexFile;}

SDFReadComplexFile::SDFReadComplexFile ()
{
	setDescriptor("Reads complex data from a file.  The simulation can be halted\n	on end-of-file, or the file contents can be periodically repeated,\n	or the file contents can be padded with zeros.");
	addPort(output.setPort("output",this,COMPLEX));
	addState(fileName.setState("fileName",this,"/dev/null","Input file"));
	addState(haltAtEnd.setState("haltAtEnd",this,"NO","Halt the run at the end of the input file."));
	addState(periodic.setState("periodic",this,"YES","Make output periodic or zero-padded."));
	addState(blockSize.setState("blockSize",this,"256","Blocksize"));
	addState(frequency.setState("frequency",this,"0.0","Frequency at which blocks will be generated"));


}

void SDFReadComplexFile::wrapup() {
# line 113 "../../../../../src/contrib/atrade/sdf/stars/SDFReadComplexFile.pl"
LOG_DEL; delete input;
}

void SDFReadComplexFile::setup() {
# line 69 "../../../../../src/contrib/atrade/sdf/stars/SDFReadComplexFile.pl"
// open input file
	LOG_NEW; input = new ifstream(expandPathName(fileName));
	if (!(*input))
		Error::abortRun(*this, "can't open file ", fileName);
	output.setSDFParams(int(blockSize), int(blockSize)-1);
}

void SDFReadComplexFile::go() {
# line 77 "../../../../../src/contrib/atrade/sdf/stars/SDFReadComplexFile.pl"
double x[2];
	  x[0] = 0.0;
	  x[1] = 0.0;

          for (int s = int(blockSize)-1; s >= 0; s--)
	    {
	    for (int i = 0; i < 2; i++)
              {
	      if (input->eof())
	        {
	        if (haltAtEnd)		// halt the run
		  SimControl::requestHalt();
	        else if (periodic)		// close and re-open file
		  {
		  LOG_DEL; delete input;
		  LOG_NEW; input = new ifstream(expandPathName(fileName));
		  if (!(*input))
                    {
		    Error::abortRun(*this, "can't re-open file ", fileName);
		    return;
		    }
		  (*input) >> x[i];		// get next value
		  ws(*input);
		  }
	        }
	      else			// get next value
	        {
	        (*input) >> x[i];
	        ws(*input);
	        }
              }
	    output%s << Complex(x[0], x[1]);
	    }
}

// prototype instance for known block list
static SDFReadComplexFile proto;
static RegisterBlock registerBlock(proto,"ReadComplexFile");
